---
apiVersion: v1
kind: List
items:
- apiVersion: v1
  kind: ConfigMap
  metadata:
    labels:
      funktion.fabric8.io/kind: Connector
      provider: fabric8
      project: connector-jira
      version: 1.1.31
      group: io.fabric8.funktion.connector
    name: jira
  data:
    deployment.yml: |
      ---
      apiVersion: extensions/v1beta1
      kind: Deployment
      metadata:
        labels:
          funktion.fabric8.io/kind: Subscription
          connector: jira
      spec:
        replicas: 1
        template:
          metadata:
            labels:
              funktion.fabric8.io/kind: Subscription
              connector: jira
          spec:
            containers:
            - image: fabric8/connector-jira:1.1.31
              name: connector
    schema.yml: |
      ---
      component:
        kind: component
        scheme: jira
        syntax: jira:type
        title: JIRA
        description: The jira component interacts with the JIRA issue tracker.
        label: api,reporting
        deprecated: false
        async: false
        javaType: org.apache.camel.component.jira.JIRAComponent
        groupId: org.apache.camel
        artifactId: camel-jira
        version: 2.18.1
      componentProperties: {}
      properties:
        type:
          kind: path
          group: common
          required: true
          type: string
          javaType: org.apache.camel.component.jira.JIRAType
          enum:
          - NEWISSUE
          - NEWCOMMENT
          deprecated: false
          secret: false
          description: Operation to perform such as create a new issue or a new comment
        password:
          kind: parameter
          group: common
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          description: Password for login
        serverUrl:
          kind: parameter
          group: common
          required: true
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          description: URL to the JIRA server
        username:
          kind: parameter
          group: common
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          description: Username for login
        bridgeErrorHandler:
          kind: parameter
          group: consumer
          label: consumer
          type: boolean
          javaType: boolean
          optionalPrefix: consumer.
          deprecated: false
          secret: false
          defaultValue: false
          description: Allows for bridging the consumer to the Camel routing Error Handler which mean any exceptions occurred while the consumer is trying to pickup incoming messages or the likes will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions that will be logged at WARN/ERROR level and ignored.
        delay:
          kind: parameter
          group: consumer
          label: consumer
          type: integer
          javaType: int
          deprecated: false
          secret: false
          defaultValue: "6000"
          description: Delay in seconds when querying JIRA using the consumer.
        jql:
          kind: parameter
          group: consumer
          label: consumer
          type: string
          javaType: java.lang.String
          deprecated: false
          secret: false
          description: JQL is the query language from JIRA which allows you to retrieve the data you want. For example jql=project=MyProject Where MyProject is the product key in Jira.
        exceptionHandler:
          kind: parameter
          group: consumer (advanced)
          label: consumer,advanced
          type: object
          javaType: org.apache.camel.spi.ExceptionHandler
          optionalPrefix: consumer.
          deprecated: false
          secret: false
          description: To let the consumer use a custom ExceptionHandler. Notice if the option bridgeErrorHandler is enabled then this options is not in use. By default the consumer will deal with exceptions that will be logged at WARN/ERROR level and ignored.
        exchangePattern:
          kind: parameter
          group: consumer (advanced)
          label: consumer,advanced
          type: string
          javaType: org.apache.camel.ExchangePattern
          enum:
          - InOnly
          - RobustInOnly
          - InOut
          - InOptionalOut
          - OutOnly
          - RobustOutOnly
          - OutIn
          - OutOptionalIn
          deprecated: false
          secret: false
          description: Sets the exchange pattern when the consumer creates an exchange.
        synchronous:
          kind: parameter
          group: advanced
          label: advanced
          type: boolean
          javaType: boolean
          deprecated: false
          secret: false
          defaultValue: false
          description: Sets whether synchronous processing should be strictly used or Camel is allowed to use asynchronous processing (if supported).
    documentation.adoc: |
      [[JIRA-JIRA]]
      JIRA
      ~~~~

      *Available as of Camel 2.15*

      The JIRA component interacts with the JIRA??API by encapsulating
      Atlassian's??https://marketplace.atlassian.com/plugins/com.atlassian.jira.jira-rest-java-client[REST
      Java Client for JIRA]. It currently provides polling for new issues and
      new comments. ??It is also able to create new issues.

      Rather than webhooks, this endpoint relies on simple polling. Reasons
      include:

      * Concern for reliability/stability
      * The types of payloads we're polling aren't typically large (plus,
      paging is available in the API)
      * The need to support apps running somewhere not publicly accessible
      where a webhook would fail

      Note that the JIRA API is fairly expansive. ??Therefore, this component
      could be easily expanded to provide additional interactions.

      Maven users will need to add the following dependency to their pom.xml
      for this component:

      [source,xml]
      ---------------------------------------
      <dependency>
          <groupId>org.apache.camel</groupId>
          <artifactId>camel-jira</artifactId>
          <version>${camel-version}</version>
      </dependency>
      ---------------------------------------

      [[JIRA-URIformat]]
      URI format
      ^^^^^^^^^^

      [source,text]
      -------------------------
      jira://endpoint[?options]
      -------------------------

      [[JIRA-Options:]]
      JIRA Options
      ^^^^^^^^^^^^^


      // component options: START
      The JIRA component has no options.
      // component options: END




      // endpoint options: START
      The JIRA component supports 10 endpoint options which are listed below:

      {% raw %}
      [width="100%",cols="2,1,1m,1m,5",options="header"]
      |=======================================================================
      | Name | Group | Default | Java Type | Description
      | type | common |  | JIRAType | *Required* Operation to perform such as create a new issue or a new comment
      | password | common |  | String | Password for login
      | serverUrl | common |  | String | *Required* URL to the JIRA server
      | username | common |  | String | Username for login
      | bridgeErrorHandler | consumer | false | boolean | Allows for bridging the consumer to the Camel routing Error Handler which mean any exceptions occurred while the consumer is trying to pickup incoming messages or the likes will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions that will be logged at WARN/ERROR level and ignored.
      | delay | consumer | 6000 | int | Delay in seconds when querying JIRA using the consumer.
      | jql | consumer |  | String | JQL is the query language from JIRA which allows you to retrieve the data you want. For example jql=project=MyProject Where MyProject is the product key in Jira.
      | exceptionHandler | consumer (advanced) |  | ExceptionHandler | To let the consumer use a custom ExceptionHandler. Notice if the option bridgeErrorHandler is enabled then this options is not in use. By default the consumer will deal with exceptions that will be logged at WARN/ERROR level and ignored.
      | exchangePattern | consumer (advanced) |  | ExchangePattern | Sets the exchange pattern when the consumer creates an exchange.
      | synchronous | advanced | false | boolean | Sets whether synchronous processing should be strictly used or Camel is allowed to use asynchronous processing (if supported).
      |=======================================================================
      {% endraw %}
      // endpoint options: END



      [[JIRA-JQL:]]
      JQL:
      ^^^^

      The JQL URI option is used by both consumer endpoints. ??Theoretically,
      items like "project key", etc. could be URI options themselves.
      ??However, by requiring the use of JQL, the consumers become much more
      flexible and powerful.

      At the bare minimum, the consumers will require the following:

      [source,text]
      --------------------------------------------------------------
      jira://[endpoint]?[required options]&jql=project=[project key]
      --------------------------------------------------------------

      One important thing to note is that the newIssue consumer will
      automatically append??"ORDER BY key desc" to your JQL. ??This is in order
      to optimize startup processing, rather than having to index every single
      issue in the project.

      Another note is that, similarly, the newComment consumer will have to
      index every single issue??*and* comment in the project. ??Therefore, for
      large projects, it's??*vital* to optimize the JQL expression as much as
      possible. ??For example,??the JIRA Toolkit Plugin includes a??"Number of
      comments" custom field -- use '"Number of comments" > 0' in your query.
      Also try to minimize based on??state (status=Open), increase the polling
      delay, etc. ??Example:

      [source,text]
      ----------------------------------------------------------------------------------------------------------------------------------------------
      jira://[endpoint]?[required options]&jql=RAW(project=[project key] AND status in (Open, \"Coding In Progress\") AND \"Number of comments\">0)"
      ----------------------------------------------------------------------------------------------------------------------------------------------
